variables:
  # format is <branch>=<name>
  # the name is used in the URL
  # latest release must be at the top
  # (only relevant on main branch)
  RELEASES: |
    v0.1=v0.1

image: fedora:rawhide

before_script:
  - dnf update -y
  - dnf install git glib2-devel gobject-introspection-devel gettext-devel meson flex bison -y
  - curl --proto '=https' --tlsv1.2 -sSf https://sh.rustup.rs | sh -s -- --default-toolchain none -y
  - source $HOME/.cargo/env
  - rustup toolchain install nightly --profile minimal --allow-downgrade -c rustfmt
  - git clone https://gitlab.gnome.org/GNOME/template-glib.git --depth=1
  - (cd template-glib && meson _build --prefix=/usr -Dintrospection=disabled -Dtests=false -Dvapi=false)
  - ninja -C template-glib/_build install
  - git submodule update --init
  - curl --proto '=https' --tlsv1.2 -sSf -o gir-rustdoc.py
    https://gitlab.gnome.org/World/Rust/gir-rustdoc/-/raw/main/gir-rustdoc.py
  - chmod +x gir-rustdoc.py

build:
  script:
    - cargo build --all-features --examples
    - cargo test

docs:
  stage: test
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
  script:
    # generate the docs
    - cargo install rustdoc-stripper
    - ./generator.py --embed-docs
    - rustup default nightly
    - eval $(./gir-rustdoc.py pre-docs)
    - cargo doc --features dox --no-deps -p template-glib -p template-glib-sys
    - mv target/doc/ docs
  artifacts:
    paths:
      - docs

pages:
  stage: deploy
  script:
    - ./gir-rustdoc.py html-index
    # main docs
    - mkdir public/git
    - mv docs public/git/docs
    # stable docs
    - ./gir-rustdoc.py docs-from-artifacts
  artifacts:
    paths:
      - public
  rules:
    - if: $CI_DEFAULT_BRANCH == $CI_COMMIT_BRANCH
